#include <windows.h>
#include <commctrl.h>
#include "CListView.h"

#define LV_MAIN_PROP "LV_PROP"
#define LV_EDIT_PROP "LV_EDIT_P"
#define LV_COMBO_PROP "LV_COMBO_P"

CListView::CListView(){
	m_hWnd = NULL;
	m_hWCombo = NULL;
	m_hWParent = NULL;
	m_iColumNum = 0;
	m_iLVOldWndProc = NULL;
	m_iOldComboWndProc = NULL;

	m_iComboSubItem = 0;
	m_iComboItem = 0;
}

CListView::~CListView(){
}

int CListView::InsertColumn(int width,int columNum,char *lpstr){
	int lRet = FALSE;
	LV_COLUMN lvC;
	
	lvC.mask = LVCF_FMT|LVCF_WIDTH|LVCF_TEXT|LVCF_SUBITEM;
	lvC.fmt = LVCFMT_LEFT;
	lvC.pszText = lpstr;
	lvC.iSubItem = columNum;
	lvC.cx = width;
	lRet = ListView_InsertColumn(m_hWnd,columNum,&lvC);

	m_iColumNum = m_iColumNum + 1;

	return lRet;
}

int CListView::InsertItem(char *fname,int item_num){
	LV_ITEM lvitem;
	int lRet;

	/*Xgr[ɓo^*/
	lvitem.mask = LVIF_TEXT|LVIF_STATE|LVIF_IMAGE|LVIF_PARAM;
	lvitem.state = 0;      
	lvitem.stateMask = 0;
	lvitem.iItem = item_num;
	lvitem.iSubItem = 0;
	lvitem.pszText = fname;
	lvitem.cchTextMax = lstrlen(fname);
	lvitem.lParam = (LPARAM)item_num;
	lvitem.iImage = 0;
	lRet = ListView_InsertItem(m_hWnd,&lvitem);

	return lRet;
}


BOOL CListView::DeleteItem(int num){
	return ListView_DeleteItem(m_hWnd,num);
}

void CListView::SetItemText(char *text,int item,int subitem)
{
	ListView_SetItemText(m_hWnd,item,subitem,text);
}

BOOL CListView::ClearItemList(void){

	return ListView_DeleteAllItems(m_hWnd);

}

BOOL CListView::GetItem(LPLVITEM pitem){
return ListView_GetItem(m_hWnd,pitem);
}

BOOL CListView::SetItem(LPLVITEM pitem){
return ListView_SetItem(m_hWnd,pitem);
}

void CListView::GetItemText(int iItem,int iSubItem,LPTSTR pszText,int cchTextMax)
{
	ListView_GetItemText(m_hWnd,iItem,iSubItem,pszText,cchTextMax);
}

int CListView::GetItemCount(void){
	return ListView_GetItemCount(m_hWnd);
}

UINT CListView::GetItemState(int i,UINT mask)
{
	return ListView_GetItemState(m_hWnd,i,mask);
}

DWORD CListView::GetExtendedListViewStyle(void){
	if(m_hWnd == NULL) return 0;
	return ListView_GetExtendedListViewStyle(m_hWnd);
}

void CListView::SetExtendedListViewStyle(DWORD dwExStyle){
	
	if(m_hWnd == NULL) return;
	ListView_SetExtendedListViewStyle(m_hWnd, dwExStyle);

}

BOOL CListView::GetCheckState(UINT iIndex){
	
	if(m_hWnd == NULL) return FALSE;
	return ListView_GetCheckState(m_hWnd, iIndex);
}

void CListView::SetCheckState(UINT iIndex,BOOL fCheck){
	
	if(m_hWnd == NULL) return;
	ListView_SetCheckState(m_hWnd, iIndex, fCheck);
}

void CListView::SetItemState(int i, UINT state, UINT mask){
	ListView_SetItemState(m_hWnd,i,state,mask);
}


//////////////////////////////////////////////////////////////////////////////
//IĂ鍀ڂ̃CfbNX()𓾂
//:iStart -> TJnCfbNX
//߂l:-1 -> Iڂ͖AȊO -> IĂ鍀ڂ̔ԍ
int CListView::GetSelectItem(int iStart){
	int idx;

	for(idx=0;idx<GetItemCount();++idx){
		if(GetItemState(idx, LVIS_SELECTED) == LVIS_SELECTED)return idx;
	}

	return -1;
}

//////////////////////////////////////////////////////////////////////////
//Xgr[TuNX
LONG CListView::SetSubClassListView(void){
	
	SetProp(m_hWnd,LV_MAIN_PROP, (HANDLE)this);

	m_iLVOldWndProc = GetWindowLong(m_hWnd,GWL_WNDPROC);
	return SetWindowLong(m_hWnd, GWL_WNDPROC, (DWORD)ListViewCallBack);
}

LONG CListView::ReSetSubClassListView(void){
	int i;
	if(m_iLVOldWndProc != NULL){
		i = SetWindowLong(m_hWnd, GWL_WNDPROC, m_iLVOldWndProc);
		m_iLVOldWndProc = NULL;
	}
	return i;
}

LRESULT CALLBACK CListView::ListViewCallBack
(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam){

	CListView* pTargetWnd = (CListView *)GetProp(hW, LV_MAIN_PROP);

	if (pTargetWnd)
    {
		switch (uMsg)
		{
		case WM_HSCROLL:
		case WM_VSCROLL:
		case WM_MOUSEWHEEL:
			if(pTargetWnd->m_hWCombo != NULL){
				pTargetWnd->ComboOK();
				pTargetWnd->DestroyComboBoxColum();
			}

			break;
		case WM_DESTROY:
			RemoveProp(hW, LV_MAIN_PROP);
			pTargetWnd->ReSetSubClassListView();
			break;
		}
		return CallWindowProc((WNDPROC)pTargetWnd->m_iLVOldWndProc,	hW, uMsg, wParam, lParam);
    }
	
	return 0;
}

//////////////////////////////////////////////////////////////////////////
//JҏWpR{{bNX
//szBuf ݒ肷镶
//num ̐
//focus tH[JXԍ
BOOL CListView::ComboBoxColum(int iItem , int iSubItem){
	RECT rc;
	HFONT hfont;

	if(m_hWCombo != NULL) return FALSE;

	//GfBbg̍ڂۑ
	m_iComboSubItem = iSubItem;
	m_iComboItem = iItem;
	
	//tOݒ肷
	m_fComboCancel = FALSE;

	//tH[JX̂鍀ڂ̈ʒu擾
	ListView_GetSubItemRect(m_hWnd,iItem,iSubItem,LVIR_BOUNDS,&rc);

	//EChE쐬
	m_hWCombo = CreateWindow("COMBOBOX",NULL,WS_CHILD|WS_BORDER|WS_VSCROLL|CBS_DROPDOWNLIST
		|CBS_DISABLENOSCROLL,
		rc.left,rc.top,
		rc.right - rc.left,(rc.bottom - rc.top) * 12,
		m_hWnd,NULL,m_hInst,NULL);

	if(m_hWCombo == NULL)return FALSE;

	//tHg𓾂 WM_GETFONT
	hfont = (HFONT)SendMessage(m_hWnd,WM_GETFONT,0,0);

	//tHgZbg WM_SETFONT
	SendMessage(m_hWCombo,WM_SETFONT,(WPARAM)hfont,0);

	/*vbvZbgĩNX̃|C^ݒ)*/
	SetProp(m_hWCombo,LV_COMBO_PROP, (HANDLE)this);

	//\
	SetFocus(m_hWCombo);
	ShowWindow(m_hWCombo,SW_SHOW);

	//TuNX
	SetSubClassCombo();

	return TRUE;
}

int CListView::ComboBoxInsertItem(int num,char *szBuf){
	if(m_hWCombo == NULL)return FALSE;
	SendMessage(m_hWCombo,CB_INSERTSTRING,num,(LPARAM)(LPCSTR)szBuf);
	return TRUE;
}

int CListView::ComboBoxSetCurSel(int num){
	if(m_hWCombo == NULL)return FALSE;
	SendMessage(m_hWCombo,CB_SETCURSEL,num,0);
	return TRUE;
						
}

int CListView::ComboBoxSelectString(int iStartIdx,char *pszStr){
	if(m_hWCombo == NULL)return 0;
	return ::SendMessage(m_hWCombo,CB_SELECTSTRING,iStartIdx,(LPARAM)pszStr);
}

int CListView::ComboOK(void){
	char text[MAX_PATH];
	int nIdx;

	if(m_hWCombo == NULL)return FALSE;
	
	nIdx = SendMessage(m_hWCombo,CB_GETCURSEL,0,0);
	if(nIdx != CB_ERR){
		LVITEM lvitem;
		ZeroMemory(&lvitem,sizeof(lvitem));

		lvitem.mask = LVIF_PARAM;
		lvitem.iItem = m_iComboItem;
		lvitem.lParam = nIdx-1;

		SetItem(&lvitem);
	}

	GetWindowText(m_hWCombo,text,MAX_PATH);
	SetItemText(text,m_iComboItem,m_iComboSubItem);
	
	if(m_hWParent != NULL)
		PostMessage(m_hWParent,WM_LV_EDIT,m_iComboItem,m_iComboSubItem);

	return TRUE;
}

int CListView::ComboCancel(void){

	return TRUE;
}

BOOL CListView::DestroyComboBoxColum(void){
	int lRet;
	if(m_hWCombo == NULL)return FALSE;

	lRet = DestroyWindow(m_hWCombo);
	if(lRet == TRUE)m_hWCombo = NULL;

	return lRet;
}

LONG CListView::SetSubClassCombo(void){
	m_iOldComboWndProc = GetWindowLong(m_hWCombo,GWL_WNDPROC);
	return SetWindowLong(m_hWCombo, GWL_WNDPROC, (DWORD)ComboCallBack);
}

LONG CListView::ReSetSubClassCombo(void){
	int i;
	if(m_iOldComboWndProc != NULL){
		i = SetWindowLong(m_hWCombo, GWL_WNDPROC, m_iOldComboWndProc);
		m_iOldComboWndProc = NULL;
	}
	return i;
}

LRESULT CALLBACK CListView::ComboCallBack(
        HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	int nVirtKey;

	CListView* pTargetWnd = (CListView *)GetProp(hW, LV_COMBO_PROP);

	if (pTargetWnd)
    {
		switch (uMsg)
		{
			case WM_KEYDOWN:

				nVirtKey = (int) wParam;
				switch(nVirtKey){
				case VK_RETURN:
					pTargetWnd->ComboOK();
					pTargetWnd->DestroyComboBoxColum();
					break;
				case VK_ESCAPE:
					pTargetWnd->ComboCancel();
					pTargetWnd->DestroyComboBoxColum();
					break;
				}
			break;

			case WM_KILLFOCUS:
				if(pTargetWnd->m_fComboCancel == FALSE){
					pTargetWnd->ComboOK();
				}
				pTargetWnd->DestroyComboBoxColum();
				break;
			case WM_DESTROY:
				RemoveProp(hW, LV_COMBO_PROP);
				pTargetWnd->ReSetSubClassCombo();
				pTargetWnd->m_hWCombo = NULL;
				break;
		}
		return CallWindowProc((WNDPROC)pTargetWnd->m_iOldComboWndProc, hW, uMsg, wParam, lParam);
    }

	return 0;
}

