#include <windows.h>
#include <stdio.h>
#include <process.h>
#include <math.h>
#include <shlobj.h>

#include "CMainWindow.h"
#include "..\Dialog\CPropCfgDlg.h"
#include "..\Dialog\CVidTVTunerDlg.h"
#include "..\Dialog\CAboutDlg.h"
#include "..\util\StrUtil.h"
#include "..\ijpeglib\BmpToJpg.h"
#include "..\Thread\ThreadSnapShot.h"
#include "..\DigiTV.h"
#include "..\resource.h"

//WXg
#define APP_REG_WND_INFO "Software\\PetitTV\\Window"

//////////////////////////////////////////////////////////////////////////////
//RXgN^
//:Ȃ
//߂l:Ȃ
CMainWindow::CMainWindow(){
	m_pDtvEngine = new CDtvEngine;
	m_hDriver = NULL;
	m_pOsdWnd = NULL;
	m_pPlayWnd = NULL;
	m_IsPopUpMenu = FALSE;
	m_hThreadSnapShot = NULL;
	m_pSplashWindow = NULL;
}

//////////////////////////////////////////////////////////////////////////////
//fRXgN^
//:Ȃ
//߂l:Ȃ
CMainWindow::~CMainWindow(){
	if(m_pDtvEngine != NULL){
		delete m_pDtvEngine;
		m_pDtvEngine = NULL;
	}
}

//////////////////////////////////////////////////////////////////////////////
//EChE쐬
//:dwExStyle ->		gEChEX^C
//     dwStyle ->		EChEX^C
//     x,y ->			EChE\W
//		nWidth ->		EChẺ
//		nHeight ->		EChȄc
//		hwndParent ->	eEChẼnh
//		hmenu ->		gp郁j[̃nh
//		hinst ->		CX^Xnh
//߂l: -> EChEnh s -> NULL
HWND CMainWindow::CreateWnd(DWORD dwExStyle,DWORD dwStyle,
			int x,int y,int nWidth,int nHeight,
			HWND hwndParent,
			HMENU hmenu,
			HINSTANCE hinst){

	if(m_hWnd != NULL)return m_hWnd;

	m_hInst = hinst;
	m_hWOwner = hwndParent;

	m_hWnd = CreateWindowEx(dwExStyle,CBASE_WINDOW_CLASS,NULL,dwStyle,
		x,y,nWidth,nHeight,hwndParent,hmenu,hinst,(VOID *)this);

	return m_hWnd;
}

const DWORD CMainWindow::OnDtvEngineEvent(CDtvEngine *pEngine, const DWORD dwEventID, PVOID pParam){
	
	switch(dwEventID){
	case DTV_EVENT_CHANGE_STREAM:
		ErrMsg("[inf]OnDtvEngineEvent : DTV_EVENT_CHANGE_STREAM");
		/*{
			ST_TV_INFOMATION stTVInfo;
			m_DbTVInfo.GetInfoIdx(m_cSetting.get_Channel(),&stTVInfo,sizeof(ST_TV_INFOMATION));
			m_pDtvEngine->SetService((WORD)stTVInfo.lSvrIdx);
		}*/
		break;
	case DTV_EVENT_SERVICENAME_UPDATE:
		{
			ErrMsg("[inf]OnDtvEngineEvent : DTV_EVENT_SERVICENAME_UPDATE");
			ST_TV_INFOMATION stTVInfo;
			m_DbTVInfo.GetInfoIdx(m_cSetting.get_Channel(),&stTVInfo,sizeof(ST_TV_INFOMATION));
			m_pDtvEngine->SetService((WORD)stTVInfo.lSvrIdx);
		}
		break;
	case DTV_EVENT_EPGPF_UPDATE:
		ErrMsg("[inf]OnDtvEngineEvent : DTV_EVENT_EPGPF_UPDATE");
		{
			char szText[120];
			szText[119] = '\0';

			GetOSDString(&szText[0],119);

			//vC[ɏ\
			if(m_pPlayWnd != NULL){
				m_pPlayWnd->SetPlayerInfo(szText);
				m_pPlayWnd->DrawPlayerInfo();
			}
		}
		break;
	default:
		ErrMsg("[inf]OnDtvEngineEvent : %08x",dwEventID);
		break;
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////////////
//DB֐
//DBJ
BOOL CMainWindow::DB_Init(void){
	m_DbTVInfo.Init();

	return TRUE;
}

//DB
BOOL CMainWindow::DB_UnInit(void){
	m_DbTVInfo.UnInit();

	return TRUE;

}

//////////////////////////////////////////////////////////////////////////////
//o֐

//ԕۑp֐
BOOL CMainWindow::SaveWndPos(void){
	int lRet;
	HKEY hKey;
	WINDOWPLACEMENT wndpl;

	if(m_hWnd == NULL) return FALSE;
	
	ZeroMemory(&wndpl,sizeof(WINDOWPLACEMENT));
	wndpl.length = sizeof(WINDOWPLACEMENT);
	lRet = GetWindowPlacement(m_hWnd,&wndpl);

	if(lRet != 0){

		lRet = RegOpenKeyEx(HKEY_CURRENT_USER,APP_REG_WND_INFO,0,KEY_WRITE,&hKey);
		if(lRet != ERROR_SUCCESS){
			lRet = RegCreateKeyEx(HKEY_CURRENT_USER,APP_REG_WND_INFO,0,NULL,0,KEY_ALL_ACCESS, NULL, &hKey, NULL);
			if(lRet != ERROR_SUCCESS){
				//MessageBox(m_hWnd,"WXg̍쐬Ɏs܂B","Error",MB_OK|MB_ICONERROR);
				return FALSE;
			}
		}
	
		RegSetValueEx(hKey,"Main_Left"		,0,REG_DWORD	,(CONST BYTE *)&wndpl.rcNormalPosition.left		,sizeof(wndpl.rcNormalPosition.left));
		RegSetValueEx(hKey,"Main_Top"		,0,REG_DWORD	,(CONST BYTE *)&wndpl.rcNormalPosition.top		,sizeof(wndpl.rcNormalPosition.top));
		RegSetValueEx(hKey,"Main_Right"		,0,REG_DWORD	,(CONST BYTE *)&wndpl.rcNormalPosition.right	,sizeof(wndpl.rcNormalPosition.right));
		RegSetValueEx(hKey,"Main_Bottom"	,0,REG_DWORD	,(CONST BYTE *)&wndpl.rcNormalPosition.bottom	,sizeof(wndpl.rcNormalPosition.bottom));

		RegCloseKey(hKey);
	}
	
	return TRUE;
}

BOOL CMainWindow::LoadWndPos(RECT *pRc){
	int lRet;
	HKEY hKey;
	DWORD dwType;
	DWORD cbData;

	if(pRc == NULL)return FALSE;

	lRet = RegOpenKeyEx(HKEY_CURRENT_USER,APP_REG_WND_INFO,0,KEY_READ,&hKey);
	if(lRet != ERROR_SUCCESS) return FALSE;

	dwType = REG_DWORD;	cbData = sizeof(pRc->left);
	lRet = RegQueryValueEx(hKey,"Main_Left",NULL,&dwType,(BYTE *)&pRc->left,&cbData);
	if(lRet != ERROR_SUCCESS) return FALSE;
	
	dwType = REG_DWORD;	cbData = sizeof(pRc->top);
	lRet = RegQueryValueEx(hKey,"Main_Top",NULL,&dwType,(BYTE *)&pRc->top,&cbData);
	if(lRet != ERROR_SUCCESS) return FALSE;
	
	dwType = REG_DWORD;	cbData = sizeof(pRc->right);
	lRet = RegQueryValueEx(hKey,"Main_Right",NULL,&dwType,(BYTE *)&pRc->right,&cbData);
	if(lRet != ERROR_SUCCESS) return FALSE;

	dwType = REG_DWORD;	cbData = sizeof(pRc->bottom);
	lRet = RegQueryValueEx(hKey,"Main_Bottom",NULL,&dwType,(BYTE *)&pRc->bottom,&cbData);
	if(lRet != ERROR_SUCCESS) return FALSE;

	RegCloseKey(hKey);

	return TRUE;
}

//EChE̐
BOOL CMainWindow::AdjustWindow(void){
	RECT rcWnd;

	//EChETCY擾
	GetClientRect(m_hWnd,&rcWnd);

	//rfIEChËʒuݒ肷
	if(m_pDtvEngine != NULL){
		m_pDtvEngine->SetViewSize(rcWnd.right-rcWnd.left,rcWnd.bottom-rcWnd.top);
	}

	return 0;
}

void CMainWindow::SetChannel(int nIdx){
	ST_TV_INFOMATION stTVInfo;
	int nCount;

	if(m_pDtvEngine == NULL)return;

	m_DbTVInfo.GetCount(&nCount);
	if(nIdx < 0 || nIdx >= nCount)return;

	//`lۑ
	m_cSetting.put_Channel(nIdx);

	//OSD\
	DrawOSDChannel();

	//擾
	m_DbTVInfo.GetInfoIdx(nIdx,&stTVInfo,sizeof(ST_TV_INFOMATION));
	
	m_pDtvEngine->SetChannel((BYTE)stTVInfo.lSpace,(WORD)stTVInfo.lChIdx);
	m_pDtvEngine->SetService((WORD)stTVInfo.lSvrIdx);
}

BOOL CMainWindow::DrawOSDMessage(char *pszStr){

	if(m_pOsdWnd == NULL)return FALSE;
	if(m_pOsdWnd->m_hWnd == NULL)return FALSE;

	//ύX
	m_pOsdWnd->SetString(pszStr);
	m_pOsdWnd->ShowString(TRUE);
	
	//EChE\
	m_pOsdWnd->Show(3500);
	
	//EChËʒuύX
	AdjustOSDWnd();

	return TRUE;
}

void CMainWindow::AdjustOSDWnd(void){
	RECT rc;

	if(m_pOsdWnd == NULL)return;
	if(m_pOsdWnd->m_hWnd == NULL)return;

	if(IsWindowVisible(m_pOsdWnd->m_hWnd) == FALSE)return;

	//EChËʒuύX
	GetClientRect(m_hWnd,&rc);

	MoveWindow(m_pOsdWnd->m_hWnd,rc.left,rc.top,
		rc.right - rc.left,
		24,TRUE);

	return;
}

void CMainWindow::GetOSDString(char *pszOSD,int cbOSD){
	wchar_t *pwszName;
	char szChName[120];

	ST_TV_INFOMATION stTVInfo;
	ST_EPG_DATA stEPG;
	
	if(m_pDtvEngine == NULL)return;

	//`l^ǖ擾
	m_DbTVInfo.GetInfoIdx(m_cSetting.get_Channel(),&stTVInfo,sizeof(ST_TV_INFOMATION));

	if(stTVInfo.nLogicalCh == 0){
		//_`lԍꍇ̏
		szChName[119] = '\0';
		pwszName = m_pDtvEngine->m_pBonSrcDecoder->GetChannelName(stTVInfo.lSpace,stTVInfo.lChIdx);
		if(pwszName != NULL){
			WideCharToMultiByte(CP_ACP, 0, pwszName, -1, szChName, 119, NULL, NULL);
		}
		else{
			szChName[0] = '\0';
		}
	}
	else{
		//_`lԍꍇ̏
		int nCh,nBrCh;
		nCh = stTVInfo.nLogicalCh / 10;
		nBrCh = stTVInfo.nLogicalCh % 10;

		if(nBrCh == 0){
			_snprintf(szChName,119,"%03d",nCh);
		}
		else{
			_snprintf(szChName,119,"%03d-%d",nCh,nBrCh);
		}
	}


	//ԑg擾
	ZeroMemory(&stEPG,sizeof(ST_EPG_DATA));
	m_pDtvEngine->GetProgramInfo(stTVInfo.lSvrID,stTVInfo.lSvrIdx,FALSE,&stEPG);

	//\e쐬
	if(stEPG.m_szEventName[0] != '\0'){
		_snprintf(pszOSD,cbOSD,"%s : %s\r\n%s",szChName,stTVInfo.szSvrName,stEPG.m_szEventName);
	}
	else{
		_snprintf(pszOSD,cbOSD,"%s : %s",szChName,stTVInfo.szSvrName);
	}
}

void CMainWindow::DrawOSDChannel(void){
	char szText[120];
	szText[119] = '\0';

	GetOSDString(&szText[0],119);

	//OSD\
	DrawOSDMessage(szText);

	//vC[ɏ\
	if(m_pPlayWnd != NULL){
		m_pPlayWnd->SetPlayerInfo(szText);
		m_pPlayWnd->DrawPlayerInfo();
	}
}

//ldbl̉ʂ߂
// : lVolume 0`100
//߂l : 0`-10000
long CMainWindow::Get_db_AudioVol(long lInVolume){
	long lSetVolume = 0;
	long lVolume;

	double fVol;
	double fTemp;

	lVolume = (100 - lInVolume) * -100;

	if(lVolume != 0 && lVolume != -10000){
		fTemp = 100.0 - (lVolume / (-100.0));

		if(lVolume != 0){
			fVol = log10(fTemp);
			lSetVolume = (5000.0 * fVol - 10000);

			if(lSetVolume != 0)lSetVolume -= 1;
		}
		else
			lSetVolume = -10000;
	}else{
		lSetVolume = lVolume;
	}

	return lSetVolume;
}

void CMainWindow::put_Volume(long lVol){

	if(lVol < 0)lVol=0;
	if(lVol > 100)lVol=100;

	//ʂ\
	char szStr[64];
	if(m_cSetting.get_IsMute() == FALSE){
		_snprintf(szStr,sizeof(szStr)-1,":%d",lVol);
	}
	else{
		_snprintf(szStr,sizeof(szStr)-1,":%d (~[g)",lVol);
	}
	DrawOSDMessage(szStr);

	//ʂۑ
	m_cSetting.put_AudioVolume(lVol);

	//ʂݒ肷
	if(m_cSetting.get_IsMute() == FALSE){
		lVol = Get_db_AudioVol(lVol);
		m_pDtvEngine->SetVolume(lVol);
	}
}

//////////////////////////////////////////////////////////////////////////////
//rfILv`EChẼ}EXzC[̓샂[h擾
//:Ȃ
//߂l:0 -> zC[Ȃ
//       1 -> 
//       2 -> `l
int CMainWindow::GetVWndWheelMode(void){
	RECT rc;
	POINT pos;
	int nWidth;

	//J[\̍W擾
	GetCursorPos(&pos);
	ScreenToClient(m_hWnd,&pos);

	//rfÏ̍擾
	GetClientRect(m_hWnd,&rc);
	
	if(pos.x > rc.left && pos.x < rc.right && 
		pos.y > rc.top && pos.y < rc.bottom){

		//////////////////////////////////////////////////////////////////////////
		//J[\̕ύX

		nWidth = (rc.right - rc.left) >> 1;

		//̈捶̓()
		if(pos.x < nWidth){
			return 1;
		}

		//̈E̓(`lύX)
		if(pos.x >= nWidth){
			return 2;
		}
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////////////
//vC[̕\XV
void CMainWindow::UpdatePlayWnd(void){

	ST_CV_PLY_FUNC_PARAM stParam;
	ZeroMemory(&stParam,sizeof(stParam));

	stParam.bIsMute = m_cSetting.get_IsMute();
	stParam.lVolume = m_cSetting.get_AudioVolume();
	stParam.nAppStat = m_cSetting.get_AppStatus();
	stParam.nTime = -1;

	//{^̏Ԃݒ肷
	m_pPlayWnd->UpdateView(&stParam);

}

int CMainWindow::GetDispTime(void){
	SYSTEMTIME sysTime;
	int nSec;

	switch(m_cSetting.get_AppStatus()){
	case VIEW_STATUS_TV_PREVIEW:
	default:
		GetLocalTime(&sysTime);
		nSec = sysTime.wHour * 3600 + sysTime.wMinute * 60 + sysTime.wSecond;
		break;
	case VIEW_STATUS_TV_RECORD:
		nSec = (m_pDtvEngine->GetRecTime()) / 1000;
		break;
	}

	return nSec;
}

//////////////////////////////////////////////////////////////////////////////
//Î~Lv`s
//:nType ->
//     pszFile
//߂l:TRUE -> AFALSE -> s
BOOL CMainWindow::CreateSnapShot(char *pszFile,int nType,int nQuality){
	
	BOOL lRet = FALSE;

	//Xbhgďꍇ

	//G[
	if(m_pDtvEngine == NULL)return FALSE;

	//Xbh쒆mF
	if(m_hThreadSnapShot != NULL){
		if(WaitForSingleObject(m_hThreadSnapShot,0) != WAIT_TIMEOUT){
			CloseHandle(m_hThreadSnapShot);
			m_hThreadSnapShot = NULL;
		}
	}
	if(m_hThreadSnapShot != NULL)return FALSE;

	//f[^擾
	ST_THREAD_SNAPSHOT *pInfo;
	pInfo = new ST_THREAD_SNAPSHOT;
	ZeroMemory(pInfo,sizeof(ST_THREAD_SNAPSHOT));

	//TCY擾
	GetVideoSize(m_cSetting.get_SnapSize(),&pInfo->m_stOutSize);

	//GW~
	m_pDtvEngine->StopEngine();

	//rbg}bv_擾
	m_pDtvEngine->m_pMediaViewer->GetSnapShot_BasicVideo(&pInfo->m_lBufSize,NULL);
	if(pInfo->m_lBufSize == 0){
		return TRUE;
	}

	pInfo->m_plDIB= (long *)new char [pInfo->m_lBufSize];
	if(m_pDtvEngine->m_pMediaViewer->GetSnapShot_BasicVideo(&pInfo->m_lBufSize,pInfo->m_plDIB) == TRUE){

		//p[^ݒ肷
		pInfo->m_nType		= nType;
		pInfo->m_nQuality	= nQuality;
		strcpy_s(pInfo->m_szFileName,MAX_PATH-1,pszFile);

		//XibvVbgXbhs
		m_hThreadSnapShot = (HANDLE)_beginthreadex(NULL,0,&ThreadSnapShot,pInfo,0,NULL);

		lRet = TRUE;
	}
	else{
		//XibvVbg̎擾Ɏs
		delete pInfo;
	}

	//GWĊJ
	m_pDtvEngine->StartEngine();
	SetChannel(m_cSetting.get_Channel());

	return lRet;

}

//////////////////////////////////////////////////////////////////////////////
//ftHg̕ۑ(^AÎ~Lv`)쐬
//:Ȃ
//߂l:Ȃ
BOOL CMainWindow::CreateDefaultSaveFolder(char *pszVideoFolder,char *pszSnapShotFolder){
	char szMyDocumentPath[MAX_PATH];
	HRESULT hr;
	BOOL lRet = FALSE;

	//hLgtH_擾
	hr = SHGetSpecialFolderPath(NULL,&szMyDocumentPath[0],CSIDL_PERSONAL,TRUE);
	if(SUCCEEDED(hr)){
		
		//^tH_̐ݒ
		if(pszVideoFolder != NULL){
			strcpy(pszVideoFolder,szMyDocumentPath);
			if(CheckPathName(pszVideoFolder) == 0)
				strcat(pszVideoFolder,"\\My Videos\\");
			else
				strcat(pszVideoFolder,"My Videos\\");
			
			CreateDirectory(pszVideoFolder,NULL);
		}

		//XibvVbgۑtH_̐ݒ
		if(pszSnapShotFolder != NULL){
			strcpy(pszSnapShotFolder,szMyDocumentPath);
			if(CheckPathName(pszSnapShotFolder) == 0)
				strcat(pszSnapShotFolder,"\\My Pictures\\");
			else
				strcat(pszSnapShotFolder,"My Pictures\\");

			CreateDirectory(pszSnapShotFolder,NULL);
		}

		lRet = TRUE;
	}

	return FALSE;
}

void CMainWindow::put_SpashWindow(CSplashWindow *pWnd){
	m_pSplashWindow = pWnd;
}

LONG WINAPI CMainWindow::VolumeCallback(LPVOID wP,long lVol){
	CMainWindow *pWnd;

	if(wP == NULL)return 0;
	pWnd = (CMainWindow *)wP;

	pWnd->put_Volume(lVol);

	return 0;
}

//rfITCY/AXyNg䂩\EChETCY߂
BOOL CMainWindow::GetVideoSize(int nMode,SIZE *pSize){
	WORD wVX,wVY;
	BYTE bAX,bAY;

	if(m_pDtvEngine == NULL)return FALSE;
	if(pSize == NULL)return FALSE;

	ErrMsg("[inf]CMainWindow::GetVideoSize");

	//TCY擾
	if(m_pDtvEngine->GetVideoSize(&wVX,&wVY) == FALSE){
		wVX = DEFAULT_WND_WIDTH;
		wVY = DEFAULT_WND_HEIGHT;
	}

	ErrMsg("[inf]CMainWindow::GetVideoSize wVX=%d , wVY=%d",wVX,wVY);

	//AXyNg擾
	if(m_pDtvEngine->GetVideoAspectRatio(&bAX,&bAY) == FALSE){
		bAX = 1;
		bAY = 1;
	}

	ErrMsg("[inf]CMainWindow::GetVideoSize bAX=%d , bAY=%d",bAX,bAY);

	//摜TCY߂
	pSize->cx = (((wVY * 100) / bAY) * bAX) / 100;
	pSize->cy = wVY;

	ErrMsg("[inf]CMainWindow::GetVideoSize cx=%d , cy=%d",pSize->cx,pSize->cy);

	switch(nMode){
	case VIDEO_SIZE_MODE_25:
		pSize->cx = (pSize->cx >> 2);
		pSize->cy = (pSize->cy >> 2);
		break;
	case VIDEO_SIZE_MODE_50:
		pSize->cx = (pSize->cx >> 1);
		pSize->cy = (pSize->cy >> 1);
		break;
	case VIDEO_SIZE_MODE_75:
		pSize->cx = (pSize->cx >> 2) * 3;
		pSize->cy = (pSize->cy >> 2) * 3;
		break;
	case VIDEO_SIZE_MODE_125:
		pSize->cx = (pSize->cx >> 2) * 5;
		pSize->cy = (pSize->cy >> 2) * 5;
		break;
	case VIDEO_SIZE_MODE_150:
		pSize->cx = (pSize->cx >> 1) * 3;
		pSize->cy = (pSize->cy >> 1) * 3;
		break;
	case VIDEO_SIZE_MODE_200:
		pSize->cx = pSize->cx << 1;
		pSize->cy = pSize->cy << 1;
		break;
	case VIDEO_SIZE_MODE_100:
	default:
		break;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//DTVGW
BOOL CMainWindow::DTV_Init(char *pszDriver){
	char szDriver[MAX_PATH];
	char szMpeg2Dec[120];
	char *pszMpeg2Dec;
	int nErrCode;
	long lVol;

	if(m_hDriver != NULL)return FALSE;

	//hCo[h
	_snprintf(szDriver,MAX_PATH-1,".\\driver\\%s",pszDriver);
	m_hDriver = LoadLibrary(szDriver);
	if(m_hDriver == NULL)return FALSE;

	//MPEG2fR[_擾
	m_cSetting.get_Mpeg2Dec(szMpeg2Dec);

	if(szMpeg2Dec[0] == '\0')
		pszMpeg2Dec = NULL;
	else
		pszMpeg2Dec = &szMpeg2Dec[0];

	nErrCode = 0;
	if(m_pDtvEngine->OpenEngine(this,m_hWnd,m_hWnd,m_hDriver,true,pszMpeg2Dec,&nErrCode) == FALSE){

		switch(nErrCode){
		case DTV_ERRCODE_INITILIZE:
			DrawOSDMessage("[G[]`[ȉɎs܂");
			break;
		case DTV_ERRCODE_BCAS:
			DrawOSDMessage("[G[]B-CASJ[h̏Ɏs܂");
			break;
		case DTV_ERRCODE_DIRECTSHOW:
			DrawOSDMessage("[G[]r[̏Ɏs܂");
			break;
		}
		
		FreeLibrary(m_hDriver);
		m_hDriver = NULL;
		
		return FALSE;
	}

	//vr[Lɂ
	m_pDtvEngine->StartEngine(TRUE);

	//`lݒ肷
	SetChannel(m_cSetting.get_Channel());

	//[hݒ肷
	m_pDtvEngine->m_pMediaViewer->SetStereoMode(m_cSetting.get_TVAudio());

	//ʂݒ肷
	if(m_cSetting.get_IsMute() == FALSE){
		lVol = Get_db_AudioVol(m_cSetting.get_AudioVolume());
		m_pDtvEngine->SetVolume(lVol);
	}
	else{
		m_pDtvEngine->SetVolume(-10000);
	}

	return TRUE;
}

BOOL CMainWindow::DTV_UnInit(void){
	//GWN[Y
	m_pDtvEngine->StopFile();
	m_pDtvEngine->StopEngine();
	m_pDtvEngine->ResetEngine();
	m_pDtvEngine->CloseEngine();

	//BonhCo
	if(m_hDriver != NULL){
		FreeLibrary(m_hDriver);
		m_hDriver = NULL;
	}

	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////
//^C}[nh
//}EXJ[\폜p^C}[
void CMainWindow::TimerProc_MouseCur(void){
	RECT rc;
	POINT pos;

	if(IsZoomed(m_hWnd) == FALSE){
		KillTimer(m_hWnd,TIMERID_MOUSECUR);
		return;
	}

	GetClientRect(m_hWnd,&rc);
	GetCursorPos(&pos);

	if(pos.x > rc.left && pos.x < rc.right &&
		pos.y > rc.top && pos.y < rc.bottom){
			SetCursor(NULL);
	}
}

void CMainWindow::TimerProc_Clock(void){

	if(m_pPlayWnd == NULL)return;

	m_pPlayWnd->DrawClock(GetDispTime());
}

//////////////////////////////////////////////////////////////////////////////
//j[XVnh
void CMainWindow::OnUpdateTopMost(HMENU hMenu){
	if(m_cSetting.get_IsTopMost() == TRUE)
		CheckMenuItem(hMenu,IDM_TOPMOST,MF_BYCOMMAND|MF_CHECKED);
	else
		CheckMenuItem(hMenu,IDM_TOPMOST,MF_BYCOMMAND|MF_UNCHECKED);
}

void CMainWindow::OnUpdateFullScreen(HMENU hMenu){
	if(IsZoomed(m_hWnd) == TRUE)
		CheckMenuItem(hMenu,IDM_FULLSCREEN,MF_BYCOMMAND|MF_CHECKED);
	else
		CheckMenuItem(hMenu,IDM_FULLSCREEN,MF_BYCOMMAND|MF_UNCHECKED);
}

void CMainWindow::OnUpdatePlayer(HMENU hMenu){
	if(m_cSetting.get_IsPlayer() == TRUE)
		CheckMenuItem(hMenu,IDM_PLAYER,MF_BYCOMMAND|MF_CHECKED);
	else
		CheckMenuItem(hMenu,IDM_PLAYER,MF_BYCOMMAND|MF_UNCHECKED);
}

void CMainWindow::OnUpdateAudioStereo(HMENU hMenu){
	if(m_cSetting.get_TVAudio() == 0)
		CheckMenuItem(hMenu,IDM_AUDIO_STEREO,MF_BYCOMMAND|MF_CHECKED);
	else
		CheckMenuItem(hMenu,IDM_AUDIO_STEREO,MF_BYCOMMAND|MF_UNCHECKED);
}

void CMainWindow::OnUpdateAudioReight(HMENU hMenu){
	if(m_cSetting.get_TVAudio() == 1)
		CheckMenuItem(hMenu,IDM_AUDIO_RIGHT,MF_BYCOMMAND|MF_CHECKED);
	else
		CheckMenuItem(hMenu,IDM_AUDIO_RIGHT,MF_BYCOMMAND|MF_UNCHECKED);
}

void CMainWindow::OnUpdateAudioLeft(HMENU hMenu){
	if(m_cSetting.get_TVAudio() == 2)
		CheckMenuItem(hMenu,IDM_AUDIO_LEFT,MF_BYCOMMAND|MF_CHECKED);
	else
		CheckMenuItem(hMenu,IDM_AUDIO_LEFT,MF_BYCOMMAND|MF_UNCHECKED);
}

//////////////////////////////////////////////////////////////////////////////
//R}hnh
void CMainWindow::OnExit(void){
	PostMessage(m_hWnd,WM_CLOSE,0,0);
}

void CMainWindow::OnCfg(void){
	CPropCfgDlg dlg;
	char szSkinFile[MAX_PATH];
	char szDriverFile[MAX_PATH];
	char szMpeg2Dec[120];
	char szStr[MAX_PATH];
	int i;
	long lIdx;
	LONG lRet;
	
	BOOL bIsNeedReset = FALSE;


	static int iSelectTab = PROP_PAGE_REC;		//I^uێϐ

	//////////////////////////////////////////////////////////////////////////
	//ݒs
	m_cSetting.get_CapDirName(&dlg.m_pDlgRec->m_szCapFileName[0]);

	dlg.m_pDlgSnap->m_iJpegQuality = m_cSetting.get_JpegQuality();
	dlg.m_pDlgSnap->m_iSnapShotFmt = m_cSetting.get_SnapShotFmt();
	dlg.m_pDlgSnap->m_nSnapSize = m_cSetting.get_SnapSize();
	m_cSetting.get_SnapDirName(&dlg.m_pDlgSnap->m_szCapFileName[0]);

	m_cSetting.get_SkinFile(szSkinFile);
	dlg.m_pDlgSkin->put_SkinFile(szSkinFile);

	for(i=0;i<12;++i){
		dlg.m_pDlgRemocon->put_Channel(i,m_cSetting.get_RemCh(i));
	}

	m_cSetting.get_DriverFile(&szDriverFile[0]);
	dlg.m_pDlgDriver->put_DriverFile(szDriverFile);

	m_cSetting.get_Mpeg2Dec(dlg.m_pdlgPreview->m_szMpeg2Dec);
	m_cSetting.get_Mpeg2Dec(szMpeg2Dec);

	//\^u̐ݒ
	dlg.m_iSelDialog = iSelectTab;

	//////////////////////////////////////////////////////////////////////////
	//_CAO\
	lRet = DialogBoxParam(m_hInst,
							MAKEINTRESOURCE(IDD_DLG_CFG),
							m_hWnd,
							(DLGPROC)CPropCfgDlg::ProckCallBack,
							(LPARAM)&dlg);

	//ŌɑIꂽ^uێ
	iSelectTab = dlg.m_iSelDialog;

	if(lRet == IDOK){
		//ݒ肪sꂽꍇ̏
		m_cSetting.put_CapDirName(dlg.m_pDlgRec->m_szCapFileName);

		m_cSetting.put_SnapDirName(dlg.m_pDlgSnap->m_szCapFileName);
		m_cSetting.put_JpegQuality(dlg.m_pDlgSnap->m_iJpegQuality);
		m_cSetting.put_SnapShotFmt(dlg.m_pDlgSnap->m_iSnapShotFmt);
		m_cSetting.put_SnapSize(dlg.m_pDlgSnap->m_nSnapSize);

		dlg.m_pDlgSkin->get_SkinFile(&szStr[0],MAX_PATH);
		if(strcmp(szSkinFile,szStr) != 0 && m_pPlayWnd != NULL){
			m_pPlayWnd->SetSkin(szStr);
			m_cSetting.put_SkinFile(szStr);

		}

		for(i=0;i<12;++i){
			dlg.m_pDlgRemocon->get_Channel(i,&lIdx);
			m_cSetting.put_RemCh(i,lIdx);
		}

		dlg.m_pDlgDriver->get_DriverFile(&szStr[0],MAX_PATH);
		if(strcmp(szDriverFile,szStr) != 0){
			m_cSetting.put_DriverFile(szStr);
		}

		if(strcmp(szMpeg2Dec,dlg.m_pdlgPreview->m_szMpeg2Dec) != 0){
			m_cSetting.put_Mpeg2Dec(dlg.m_pdlgPreview->m_szMpeg2Dec);
			bIsNeedReset = TRUE;
		}

		//ݒۑ
		m_cSetting.Save();

		//vC[XV
		if(m_pPlayWnd != NULL){
			ST_CV_PLY_FUNC_PARAM stParam;
			ZeroMemory(&stParam,sizeof(stParam));

			stParam.bIsMute = m_cSetting.get_IsMute();
			stParam.lVolume = m_cSetting.get_AudioVolume();

			m_pPlayWnd->UpdateView(&stParam);
		}
		
		//Kvɉčŏ
		if(bIsNeedReset == TRUE)
		{
			//hCo
			DTV_UnInit();

			//hCo
			m_cSetting.get_DriverFile(szStr);
			DTV_Init(szStr);
		}
	}
}

void CMainWindow::OnRecStart(void){
	if(m_pDtvEngine == NULL)return;
	if(m_pDtvEngine->IsCapture() == TRUE)return;

	char szCapFile[MAX_PATH];
	char szTime[24];

	int iYear;
	SYSTEMTIME sysTime;

	ErrMsg("[Inf]CMainWindow::OnRecStart");

	//^t@Cݒ肷
	m_cSetting.get_CapDirName(szCapFile);

	if(CheckPathName(szCapFile) == 0){
		strcat(szCapFile,"\\");
	}

	//t@C쐬
	strcat(szCapFile,"cap");

	GetLocalTime(&sysTime);
	iYear = sysTime.wYear % 100;
	sprintf(szTime,"_%02d_%02d%02d%02d%02d%02d.TS",m_cSetting.get_Channel(),iYear,sysTime.wMonth,sysTime.wDay,sysTime.wHour,sysTime.wMinute);
	strcat(szCapFile,szTime);

	//t@C̏d`FbNAC
	CheckFileExist(szCapFile);

	//^Jn
	m_pDtvEngine->StartCapture(szCapFile);

	//Xe[^Xݒ肷
	m_cSetting.put_AppStatus(VIEW_STATUS_TV_RECORD);

	//\XV
	UpdatePlayWnd();
}

void CMainWindow::OnRecStop(void){
	if(m_pDtvEngine == NULL)return;
	if(m_pDtvEngine->IsCapture() == FALSE)return;

	//^~
	m_pDtvEngine->StopCapture();

	//Xe[^Xݒ肷
	m_cSetting.put_AppStatus(VIEW_STATUS_TV_PREVIEW);

	//vC[̃Xe[^XXV
	m_pPlayWnd->DrawPlayerStat(VIEW_STATUS_TV_PREVIEW);

	//\XV
	UpdatePlayWnd();
}

void CMainWindow::OnStop(void){
	if(m_pDtvEngine == NULL)return;
	
	//^撆̏ꍇ̏
	if(m_pDtvEngine->IsCapture() == TRUE){
		OnRecStop();
	}
}

void CMainWindow::OnTunerCfg(void){
	CVidTVTunerDlg dlg;
	LONG lRet;
	BOOL bIsEnablePreview;

	if(m_pDtvEngine == NULL)return;

	//vC[̏Ԃ擾
	bIsEnablePreview = m_pDtvEngine->IsEnablePreview();
	if(bIsEnablePreview == TRUE){
		m_pDtvEngine->StopEngine();
	}

	//vr[Ȃŏs
	m_pDtvEngine->StartEngine(FALSE);

	//////////////////////////////////////////////////////////////////////////
	//ݒs
	dlg.m_pDBTvInfo = &m_DbTVInfo;
	dlg.m_pDtvEngine = m_pDtvEngine;

	//////////////////////////////////////////////////////////////////////////
	//_CAO\
	lRet = DialogBoxParam(m_hInst,
							MAKEINTRESOURCE(IDD_TUNER_CFG),
							m_hWnd,
							(DLGPROC)CVidTVTunerDlg::ProckCallBack,
							(LPARAM)&dlg);

	//GW~
	m_pDtvEngine->StopEngine();
	m_pDtvEngine->ResetEngine();

	//Rݒ肪ꍇ
	int i,nCount;
	ST_TV_INFOMATION stInfo;
	for(i=0;i<12;++i){
		if(m_cSetting.get_RemCh(i) >= 0)break;
	}
	if(i >= 12){
		m_DbTVInfo.GetCount(&nCount);
		for(i=0;i<nCount;++i){
			m_DbTVInfo.GetInfoIdx(i,&stInfo,sizeof(ST_TV_INFOMATION));
			if(stInfo.lSvrIdx != 0 || stInfo.nRmCtrlKeyID == 0)continue;

			if(m_cSetting.get_RemCh(stInfo.nRmCtrlKeyID-1) < 0)
				m_cSetting.put_RemCh(stInfo.nRmCtrlKeyID-1,i);
		}
	}

	//vC[̏Ԃɖ߂
	if(bIsEnablePreview == TRUE){
		m_pDtvEngine->StartEngine(TRUE);
		
		//`lݒ肷
		SetChannel(m_cSetting.get_Channel());
	}
}

void CMainWindow::OnSetChannel(int nIdx){
	SetChannel(nIdx);
}

void CMainWindow::OnSetChannelRmt(int nIdx){
	
	//`lݒ肷
	int nChIdx = m_cSetting.get_RemCh(nIdx);
	if(nChIdx != -1)
		SetChannel(nChIdx);

}


void CMainWindow::OnFullScreen(void){
	if(m_hWnd == NULL)return;

	DWORD dwStyle;
	dwStyle = GetWindowLong(m_hWnd,GWL_STYLE);

	if(IsZoomed(m_hWnd) == TRUE){
		dwStyle = dwStyle | WS_THICKFRAME;
		SetWindowLong(m_hWnd,GWL_STYLE,dwStyle);
		ShowWindow(m_hWnd,SW_RESTORE);
	}
	else{
		dwStyle = (dwStyle & (~WS_THICKFRAME));
		SetWindowLong(m_hWnd,GWL_STYLE,dwStyle);
		ShowWindow(m_hWnd,SW_MAXIMIZE);
	}
}

void CMainWindow::OnShowInfo(void){
	DrawOSDChannel();
}

void CMainWindow::OnTopMost(){
	if(m_cSetting.get_IsTopMost() == TRUE){
		SetWindowPos(m_hWnd,HWND_NOTOPMOST,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);
		m_cSetting.put_IsTopMost(FALSE);
	}
	else{
		SetWindowPos(m_hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);
		m_cSetting.put_IsTopMost(TRUE);
	}
}

void CMainWindow::OnVolMute(void){
	BOOL IsMute;
	long lVol;

	IsMute = m_cSetting.get_IsMute();

	if(IsMute == TRUE)
		IsMute = FALSE;
	else
		IsMute= TRUE;

	if(IsMute == TRUE){
		DrawOSDMessage("~[g");
		m_pDtvEngine->SetVolume(-10000);
	}
	else{
		DrawOSDMessage("~[g");
		lVol = Get_db_AudioVol(m_cSetting.get_AudioVolume());
		m_pDtvEngine->SetVolume(lVol);
	}

	m_cSetting.put_IsMute(IsMute);

	//{[o[ĕ`悷
	if(m_pPlayWnd != NULL){
		m_pPlayWnd->DrawVolume(m_cSetting.get_AudioVolume());
	}
}

void CMainWindow::OnVolUp(void){
	long lVol;

	//ʂ炷
	lVol = m_cSetting.get_AudioVolume();
	lVol += 1;
	
	put_Volume(lVol);

	//{[o[ĕ`悷
	if(m_pPlayWnd != NULL){
		m_pPlayWnd->DrawVolume(m_cSetting.get_AudioVolume());
	}
}

void CMainWindow::OnVolDown(void){
	long lVol;

	//ʂ炷
	lVol = m_cSetting.get_AudioVolume();

	lVol -= 1;
	if(lVol < 0)lVol = 0;

	put_Volume(lVol);

	//{[o[ĕ`悷
	if(m_pPlayWnd != NULL){
		m_pPlayWnd->DrawVolume(m_cSetting.get_AudioVolume());
	}
}

void CMainWindow::OnChUp(void){
	int nCount;
	int nCurCh;
	int nIdx;
	ST_TV_INFOMATION stInfo;
	BOOL bFound = FALSE;
	
	m_DbTVInfo.GetCount(&nCount);
	nCurCh = m_cSetting.get_Channel();

	//`lT
	for(nIdx = nCurCh+1;nIdx<nCount;++nIdx){
		if(m_DbTVInfo.GetInfoIdx(nIdx,&stInfo,sizeof(ST_TV_INFOMATION)) == FALSE)continue;
		if(stInfo.IsSignal == FALSE)continue;
		bFound = TRUE;
		break;
	}

	if(bFound == FALSE){
		for(nIdx = 0;nIdx<nCurCh;++nIdx){
			if(m_DbTVInfo.GetInfoIdx(nIdx,&stInfo,sizeof(ST_TV_INFOMATION)) == FALSE)continue;
			if(stInfo.IsSignal == FALSE)continue;
			bFound = TRUE;
			break;
		}
	}

	//`lꍇ̏
	if(bFound == TRUE){
		SetChannel(nIdx);
	}
}

void CMainWindow::OnChDown(void){
	int nCount;
	int nCurCh;
	int nIdx;
	ST_TV_INFOMATION stInfo;
	BOOL bFound = FALSE;
	
	m_DbTVInfo.GetCount(&nCount);
	nCurCh = m_cSetting.get_Channel();

	//`lT
	for(nIdx = nCurCh-1;nIdx>=0;--nIdx){
		if(m_DbTVInfo.GetInfoIdx(nIdx,&stInfo,sizeof(ST_TV_INFOMATION)) == FALSE)continue;
		if(stInfo.IsSignal == FALSE)continue;
		bFound = TRUE;
		break;
	}

	if(bFound == FALSE){
		for(nIdx = nCount-1;nIdx>nCurCh;--nIdx){
			if(m_DbTVInfo.GetInfoIdx(nIdx,&stInfo,sizeof(ST_TV_INFOMATION)) == FALSE)continue;
			if(stInfo.IsSignal == FALSE)continue;
			bFound = TRUE;
			break;
		}
	}

	//`lꍇ̏
	if(bFound == TRUE){
		SetChannel(nIdx);
	}
}

void CMainWindow::OnSnapShot(void){

	char szCapFile[MAX_PATH];
	char szTime[24];

	int iYear;
	SYSTEMTIME sysTime;

	ErrMsg("[Inf]CMainWindow::OnSnapShot");

	//^撆͏sȂ
	if(m_cSetting.get_AppStatus() == VIEW_STATUS_TV_RECORD)return;

	//^t@Cݒ肷
	m_cSetting.get_SnapDirName(szCapFile);

	if(CheckPathName(szCapFile) == 0){
		strcat(szCapFile,"\\");
	}

	//t@C쐬
	strcat(szCapFile,"snap");

	GetLocalTime(&sysTime);
	iYear = sysTime.wYear % 100;
	sprintf(szTime,"_%02d_%02d%02d%02d%02d%02d",m_cSetting.get_Channel(),iYear,sysTime.wMonth,sysTime.wDay,sysTime.wHour,sysTime.wMinute);
	strcat(szCapFile,szTime);

	switch(m_cSetting.get_SnapShotFmt()){
	case PTDIGI_SNAP_FMT_BMP:
		strcat(szCapFile,".BMP");
		break;
	case PTDIGI_SNAP_FMT_JPG:
		strcat(szCapFile,".JPG");
		break;
	}
	
	//t@C̏d`FbNAC
	CheckFileExist(szCapFile);

	ErrMsg("[Inf]CMainWindow::OnSnapShot => %s",szCapFile);

	//vC[̏Ԃ擾
	if(CreateSnapShot(szCapFile,m_cSetting.get_SnapShotFmt(),m_cSetting.get_JpegQuality()) == FALSE){
		DrawOSDMessage("G[FXibvVbg̎擾o܂łB");
	}
}

void CMainWindow::OnPlayer(void){
	if(m_pPlayWnd == NULL)return;
	if(IsWindowVisible(m_pPlayWnd->m_hWnd) == TRUE){
		ShowWindow(m_pPlayWnd->m_hWnd,SW_HIDE);
		m_cSetting.put_IsPlayer(FALSE);

	}
	else{
		ShowWindow(m_pPlayWnd->m_hWnd,SW_SHOW);
		m_cSetting.put_IsPlayer(TRUE);
	}

}

void CMainWindow::OnAudioStereo(void){
	if(m_pDtvEngine == NULL)return;
	m_pDtvEngine->m_pMediaViewer->SetStereoMode(0);
	m_cSetting.put_TVAudio(0);
}

void CMainWindow::OnAudioRight(void){
	if(m_pDtvEngine == NULL)return;
	m_pDtvEngine->m_pMediaViewer->SetStereoMode(1);
	m_cSetting.put_TVAudio(1);
}

void CMainWindow::OnAudioLeft(void){
	if(m_pDtvEngine == NULL)return;
	m_pDtvEngine->m_pMediaViewer->SetStereoMode(2);
	m_cSetting.put_TVAudio(2);
}

void CMainWindow::OnAudioChange(void){
	int nMode;
	nMode = m_cSetting.get_TVAudio();
	++nMode;
	if(nMode > 2)nMode = 0;

	switch(nMode){
	case 0:
		DrawOSDMessage("XeI({)");
		break;
	case 1:
		DrawOSDMessage("剹(Ê)");
		break;
	case 2:
		DrawOSDMessage("(̂)");
		break;
	}

	m_pDtvEngine->m_pMediaViewer->SetStereoMode(nMode);
	m_cSetting.put_TVAudio(nMode);
}

void CMainWindow::OnVideo25(void){
	SIZE stSize;
	if(GetVideoSize(VIDEO_SIZE_MODE_25,&stSize) == FALSE)return;
	SetWindowPos(m_hWnd,NULL,0,0,stSize.cx,stSize.cy,SWP_NOMOVE|SWP_NOZORDER);
}

void CMainWindow::OnVideo50(void){
	SIZE stSize;
	if(GetVideoSize(VIDEO_SIZE_MODE_50,&stSize) == FALSE)return;
	SetWindowPos(m_hWnd,NULL,0,0,stSize.cx,stSize.cy,SWP_NOMOVE|SWP_NOZORDER);
}

void CMainWindow::OnVideo100(void){
	SIZE stSize;
	if(GetVideoSize(VIDEO_SIZE_MODE_100,&stSize) == FALSE)return;
	SetWindowPos(m_hWnd,NULL,0,0,stSize.cx,stSize.cy,SWP_NOMOVE|SWP_NOZORDER);
}

void CMainWindow::OnVideo75(void){
	SIZE stSize;
	if(GetVideoSize(VIDEO_SIZE_MODE_75,&stSize) == FALSE)return;
	SetWindowPos(m_hWnd,NULL,0,0,stSize.cx,stSize.cy,SWP_NOMOVE|SWP_NOZORDER);
}

void CMainWindow::OnVideo125(void){
	SIZE stSize;
	if(GetVideoSize(VIDEO_SIZE_MODE_125,&stSize) == FALSE)return;
	SetWindowPos(m_hWnd,NULL,0,0,stSize.cx,stSize.cy,SWP_NOMOVE|SWP_NOZORDER);
}

void CMainWindow::OnAbout(void){
	CAboutDlg dlg;

	if(FindWindowEx(m_hWnd,NULL,NULL,"̃\tgɂ") != NULL) return;

	//_CAO\
	DialogBoxParam(m_hInst,
						MAKEINTRESOURCE(IDD_ABOUT),
						m_hWnd,
						(DLGPROC)dlg.ProckCallBack,
						(LPARAM)&dlg);
}

//////////////////////////////////////////////////////////////////////////////
//bZ[Wnh
LRESULT CMainWindow::OnWmCreate(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam){

	m_hWnd = hW;
	RECT rc;
	char szStr[MAX_PATH];

	//ݒǂݍ
	if(m_cSetting.Load() == FALSE){
		char szCapDir[MAX_PATH],szSnapDir[MAX_PATH];

		CreateDefaultSaveFolder(szCapDir,szSnapDir);

		m_cSetting.put_CapDirName(szCapDir);
		m_cSetting.put_SnapDirName(szSnapDir);

		m_cSetting.put_SkinFile("PetitTV.SKN");

		m_cSetting.put_DriverFile("BonDriver_HDUS.dll");
	}

	//Xe[^Xݒ肷
	m_cSetting.put_AppStatus(VIEW_STATUS_TV_PREVIEW);

	//bZ[W\
	if(m_pSplashWindow != NULL){
		m_pSplashWindow->DrawMessage(16,16,"EChE쐬");
	}

	//OSDEChE쐬
	if(m_pOsdWnd == NULL){
		m_pOsdWnd = new CMsgWindow;
		
		if(m_pOsdWnd != NULL){
			m_pOsdWnd->CreateWnd(0,WS_CHILD,0,0,0,0,m_hWnd,NULL,m_hInst);

			m_pOsdWnd->SetBackColor(RGB(0,0,0));
			m_pOsdWnd->SetStringColor(RGB(255,255,255));
			m_pOsdWnd->SetPosition(16,4);
			m_pOsdWnd->SetFontSize(16);
		}
	}

	//vC[EChE쐬
	if(m_pPlayWnd == NULL){
		m_pPlayWnd = new CMiniCtrlWnd;

		//ݒs
		m_pPlayWnd->put_cSetting(&m_cSetting);
		m_pPlayWnd->SetVolumeCallBack(VolumeCallback,this);
		m_pPlayWnd->DrawClock(GetDispTime());

		if(m_pPlayWnd->LoadWndPos(&rc) == FALSE){
			GetWindowRect(m_hWnd,&rc);
			rc.left = rc.right + 1;
			rc.right = rc.right + 1;
			rc.bottom = rc.top;
		}
		
		m_pPlayWnd->CreateWnd(0,
			WS_POPUP|WS_CHILD,
			rc.left,rc.top,
			rc.right - rc.left,rc.bottom - rc.top,
			m_hWnd,
			NULL,
			m_hInst);
	}

	//bZ[W\
	if(m_pSplashWindow != NULL){
		m_pSplashWindow->DrawMessage(16,32,"ݒǂݍݒ");
	}

	//DBǂݍ
	DB_Init();

	//bZ[W\
	if(m_pSplashWindow != NULL){
		m_pSplashWindow->DrawMessage(16,48,"`[i");
	}

	//DTVGW
	m_cSetting.get_DriverFile(&szStr[0]);
	DTV_Init(szStr);
	
	//tOwɂEChEőOʂɂ
	if(m_cSetting.get_IsTopMost() == TRUE){
		SetWindowPos(m_hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);
	}

	//vC[\
	if(m_cSetting.get_IsPlayer() == TRUE && m_pPlayWnd != NULL){
		ShowWindow(m_pPlayWnd->m_hWnd,SW_SHOW);
		UpdateWindow(m_pPlayWnd->m_hWnd);
	}

	//bZ[W\
	if(m_pSplashWindow != NULL){
		m_pSplashWindow->DrawMessage(16,64,"N");
	}

	//^C}[ݒ肷
	SetTimer(m_hWnd,TIMERID_CLOCK,1000,NULL);

	return 0;
}

LRESULT CMainWindow::OnWmClose(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam){
	//^撆͏IȂ
	if(m_cSetting.get_AppStatus() == VIEW_STATUS_TV_RECORD){
		if(MessageBox(m_hWnd,"=== ^撆łB===\nAIƘ^悪f܂B\n{ɏI܂H",
			MASSAGE_TITLE,MB_YESNO) == IDNO) return 0;
	}

	//EChE\ɂ
#if 0
	ShowWindow(hW,SW_HIDE);
	if(m_pPlayWnd != NULL){
		ShowWindow(m_pPlayWnd->m_hWnd,SW_HIDE);
	}
#endif

	//XbhN[Y
	if(m_hThreadSnapShot != NULL){
		if(WaitForSingleObject(m_hThreadSnapShot,10000) != WAIT_TIMEOUT){
			CloseHandle(m_hThreadSnapShot);
			m_hThreadSnapShot = NULL;
		}
	}

	//^C}[~
	KillTimer(m_hWnd,TIMERID_CLOCK);

	//hCo
	DTV_UnInit();

	//DB
	DB_UnInit();

	//ݒۑ
	m_cSetting.Save();
	SaveWndPos();

	//OSDEChEj
	if(m_pOsdWnd != NULL){
		SendMessage(m_pOsdWnd->m_hWnd,WM_CLOSE,0,0);
		delete m_pOsdWnd;
		m_pOsdWnd = NULL;
	}

	//OSDEChEj
	if(m_pPlayWnd != NULL){
		SendMessage(m_pPlayWnd->m_hWnd,WM_CLOSE,0,0);
		delete m_pPlayWnd;
		m_pPlayWnd = NULL;
	}

	//EChEj
	DestroyWindow(hW);

	return 0;
}

LRESULT CMainWindow::OnWmSize(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam){

	switch(wParam){
	case SIZE_MAXIMIZED:
		//}EX^C}[ݒ肷
		if(m_hWnd != NULL){
			SetTimer(m_hWnd,TIMERID_MOUSECUR,TIME_MOUSECUR,NULL);
		}
		break;
	case SIZE_RESTORED:
		//}EX^C}[
		if(m_hWnd != NULL){
			KillTimer(m_hWnd,TIMERID_MOUSECUR);
		}

		//plɖ߂
		if(m_pPlayWnd != NULL){
			if(m_cSetting.get_IsPlayer() == TRUE && IsWindowVisible(m_pPlayWnd->m_hWnd) == FALSE){
				ShowWindow(m_pPlayWnd->m_hWnd,SW_SHOW);
			}
		}
		break;
	}

	AdjustWindow();

	return 0;
}

LRESULT CMainWindow::OnWmRButtonDown(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam){
	HMENU hMenu;
	HMENU hMenuChannel;
	POINT pos;
	int i,nCount;
	MENUITEMINFO mi;
	ST_TV_INFOMATION stTVInfo;

	hMenu = GetSubMenu(LoadMenu(m_hInst,MAKEINTRESOURCE(IDR_MENU_RCLICK)),0);
	
	if(IsZoomed(m_hWnd) == TRUE){
		KillTimer(m_hWnd,TIMERID_MOUSECUR);
	}

	m_IsPopUpMenu = TRUE;

	//}EẌʒu擾
	GetCursorPos(&pos);

	//W̃J[\ɕύX
	SetCursor(LoadCursor(NULL,IDC_ARROW));

	//`lj[쐬
	hMenuChannel = GetSubMenu(hMenu,5);
	
	//ACe擾
	m_DbTVInfo.GetCount(&nCount);

	//`lj[ɒǉ
	for(i=0;i<nCount;++i){
		m_DbTVInfo.GetInfoIdx(i,&stTVInfo,sizeof(ST_TV_INFOMATION));
		if(stTVInfo.IsSignal == FALSE)continue;

		ZeroMemory(&mi,sizeof(MENUITEMINFO));

		mi.cbSize		= sizeof(MENUITEMINFO);
		mi.fMask		= MIIM_TYPE | MIIM_ID;
		mi.wID			= IDM_CH_0IDX + i;
		mi.fType		= MFT_STRING;
		mi.dwTypeData	= &stTVInfo.szSvrName[0];
		mi.cch			= strlen(stTVInfo.szSvrName);

		InsertMenuItem(hMenuChannel,i,TRUE,&mi);

		if(i == m_cSetting.get_Channel()){
			CheckMenuItem(hMenuChannel,(IDM_CH_0IDX + i),MF_BYCOMMAND|MF_CHECKED);
		}

		if(m_cSetting.get_AppStatus() == VIEW_STATUS_TV_RECORD){
			EnableMenuItem(hMenuChannel,(IDM_CH_0IDX + i),MF_BYCOMMAND|MF_GRAYED);
		}
	}
	DeleteMenu(hMenuChannel,IDM_DUMMY,MF_BYCOMMAND);

	//j[\
	TrackPopupMenu(hMenu,TPM_LEFTALIGN,pos.x,pos.y,0,hW,NULL);

	return 0;
}

LRESULT CMainWindow::OnWmLButtonDown(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam){
	POINT pos;

	if(IsZoomed(m_hWnd) == FALSE){
		//ʏ펞̕\̏ꍇ
		GetCursorPos(&pos);
		PostMessage(hW,WM_NCLBUTTONDOWN,(WPARAM)HTCAPTION,MAKELONG(pos.x,pos.y));
	
	}
	else{
		//tXN[\̏ꍇ
		if(m_pPlayWnd != NULL && m_cSetting.get_IsPlayer() == TRUE){
			if(IsWindowVisible(m_pPlayWnd->m_hWnd) == TRUE)
				ShowWindow(m_pPlayWnd->m_hWnd,SW_HIDE);
			else
				ShowWindow(m_pPlayWnd->m_hWnd,SW_SHOW);
		}
	}

	return 0;
}

LRESULT CMainWindow::OnWMLButtonDbclk(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam){
	OnFullScreen();

	return 0;
}

LRESULT CMainWindow::OnWmDestroy(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam){
	
	PostQuitMessage(0);
	
	return 0;
}

LRESULT CMainWindow::OnWmSysCommand(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam)
{

	switch(wParam)
	{
	case SC_SCREENSAVE:
	case SC_MONITORPOWER:
		ErrMsg("[Inf]CMainWindow::OnWmSysCommand <SC_SCREENSAVE>");
		return TRUE;
		break;
#if 0
	case SC_RESTORE:
		if(m_pPlayWnd != NULL){
			if(m_cSetting.get_IsPlayer() == TRUE && IsWindowVisible(m_pPlayWnd->m_hWnd) == FALSE){
				ShowWindow(m_pPlayWnd->m_hWnd,SW_SHOW);
			}
		}
		break;
#endif
	}
	return DefWindowProc(hW,uMsg,wParam,lParam);
}

LRESULT CMainWindow::OnWmInitMenu(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam){
	HMENU hMenu = (HMENU)wParam;

	//j[XVnh
	OnUpdateTopMost(hMenu);
	OnUpdateFullScreen(hMenu);
	OnUpdatePlayer(hMenu);
	OnUpdateAudioStereo(hMenu);
	OnUpdateAudioReight(hMenu);
	OnUpdateAudioLeft(hMenu);

	return 0;
}

LRESULT CMainWindow::OnWmMenuSelect(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam){
	UINT uFlag = HIWORD(wParam);
	UINT idx = LOWORD(wParam);

	HMENU hMenu = (HMENU)lParam;

	if(uFlag == 0xffff){

		m_IsPopUpMenu = FALSE;

		if(IsZoomed(m_hWnd) == TRUE){
			SetTimer(m_hWnd,TIMERID_MOUSECUR,TIME_MOUSECUR,NULL);
		}
	}

	return 0;
}

LRESULT CMainWindow::OnWmMouseMove(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam){

	int xPos = GET_X_LPARAM(lParam);	// J[\̐̈ʒu
	int yPos = GET_Y_LPARAM(lParam);	// J[\̐̈ʒu

	if(IsZoomed(m_hWnd) == TRUE){
		KillTimer(m_hWnd,TIMERID_MOUSECUR);
		SetTimer(m_hWnd,TIMERID_MOUSECUR,TIME_MOUSECUR,NULL);
	}

	//J[\̕ύX
	if(m_IsPopUpMenu == FALSE){
 
		switch(GetVWndWheelMode()){
		case 1:
			SetCursor(LoadCursor(m_hInst,MAKEINTRESOURCE(IDC_CURSOR_VOL)));
			break;
		case 2:
			SetCursor(LoadCursor(m_hInst,MAKEINTRESOURCE(IDC_CURSOR_CH)));
			break;
		}
	}

	return 0;
}

#ifdef WM_MOUSEWHEEL
LRESULT CMainWindow::OnWmMouseWheel(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam){
	int xPos = GET_X_LPARAM(lParam);	// J[\̐̈ʒu
	int yPos = GET_Y_LPARAM(lParam);	// J[\̐̈ʒu

	int zDelta;

	zDelta = GET_WHEEL_DELTA_WPARAM(wParam);

	ErrMsg("[Inf]CMainWindow::OnWmMouseWheel : xPos=%d , yPos=%d , zDelta=%d",xPos,yPos,zDelta);

	switch(GetVWndWheelMode()){
	case 1: //ʒ
		if(zDelta > 0){
			//ʃAbv̏
			OnVolUp();
		}
		else{
			//ʃ_Ȅ
			OnVolDown();
		}
		break;
	case 2:
		if(zDelta > 0){
			//CHAbv̏
			OnChUp();
		}
		else{
			//CH_Ȅ
			OnChDown();
		}
		break;
	
	default:
		break;
	}
	
	return 0;
}
#endif //WM_MOUSEWHEEL

LRESULT CMainWindow::OnWmTimer(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam){

	//if(m_hEndEvent == NULL)return 0;
	//if(WaitForSingleObject(m_hEndEvent,0 ) != WAIT_TIMEOUT)return 0;

	switch(wParam){
	case TIMERID_MOUSECUR:
		TimerProc_MouseCur();
		break;
	case TIMERID_CLOCK:
		TimerProc_Clock();
		break;
	}

	return 0;
}

LRESULT CMainWindow::OnWmCommand(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam){
	
	if(lParam == NULL){
		ErrMsg("[Inf]OnWmCommand lParam = %08x",lParam);
		switch(LOWORD(wParam)){
		case IDM_CFG:
			OnCfg();
			break;
		case IDM_EXIT:
			OnExit();
			break;
		case IDM_REC_START:
			OnRecStart();
			break;
		case IDM_REC_STOP:
			OnRecStop();
			break;
		case IDM_STOP:
			OnStop();
			break;
		case IDM_CHANNEL_CFG:
			OnTunerCfg();
			break;
		case IDM_FULLSCREEN:
			OnFullScreen();
			break;
		case IDM_TOPMOST:
			OnTopMost();
			break;
		case IDM_VOL_MUTE:
			OnVolMute();
			break;
		case IDM_VOL_UP:
			OnVolUp();
			break;
		case IDM_VOL_DOWN:
			OnVolDown();
			break;
		case IDM_CH_UP:
			OnChUp();
			break;
		case IDM_CH_DOWN:
			OnChDown();
			break;
		case IDM_SNAPSHOT:
			OnSnapShot();
			break;
		case IDM_PLAYER:
			OnPlayer();
			break;
		case IDM_AUDIO_STEREO:
			OnAudioStereo();
			break;
		case IDM_AUDIO_RIGHT:
			OnAudioRight();
			break;
		case IDM_AUDIO_LEFT:
			OnAudioLeft();
			break;
		case IDM_AUDIO_CHANGE:
			OnAudioChange();
			break;
		case IDM_VIDEO_25:
			OnVideo25();
			break;
		case IDM_VIDEO_50:
			OnVideo50();
			break;
		case IDM_VIDEO_75:
			OnVideo75();
			break;
		case IDM_VIDEO_100:
			OnVideo100();
			break;
		case IDM_VIDEO_125:
			OnVideo125();
			break;
		case IDM_SHOW_INFO:
			OnShowInfo();
			break;
		case IDM_ABOUT:
			OnAbout();
			break;
		default:
			//`lȈ
			if(LOWORD(wParam) >= IDM_CH_0IDX && LOWORD(wParam) < IDM_CH_0IDX+120){
				OnSetChannel(LOWORD(wParam) - IDM_CH_0IDX);
			}
			else if(LOWORD(wParam) >= IDM_CH_RMT_0IDX && LOWORD(wParam) < IDM_CH_RMT_0IDX+12){
				OnSetChannelRmt(LOWORD(wParam) - IDM_CH_RMT_0IDX);
			}
			break;
		}
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////////////
//EChEvVbW
//:
//߂l:
LRESULT CMainWindow::WndProck(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){
	LRESULT lRet = 0;

	switch (uMsg){
	case WM_CREATE:
		OnWmCreate(hWnd, uMsg, wParam, lParam);
		break;
	case WM_CLOSE:
		OnWmClose(hWnd, uMsg, wParam, lParam);
		break;
	case WM_COMMAND:
		lRet = OnWmCommand(hWnd, uMsg, wParam, lParam);
		break;
	case WM_DESTROY:
		OnWmDestroy(hWnd, uMsg, wParam, lParam);
		break;
	case WM_SIZE:
		OnWmSize(hWnd, uMsg, wParam, lParam);
		break;
	case WM_RBUTTONDOWN:
		OnWmRButtonDown(hWnd, uMsg, wParam, lParam);
		break;
	case WM_LBUTTONDOWN:
		OnWmLButtonDown(hWnd, uMsg, wParam, lParam);
		break;
	case WM_LBUTTONDBLCLK:
		OnWMLButtonDbclk(hWnd, uMsg, wParam, lParam);
		break;
	case WM_INITMENU:
		lRet = OnWmInitMenu(hWnd, uMsg, wParam, lParam);
		break;
	case WM_SYSCOMMAND:
		OnWmSysCommand(hWnd,uMsg,wParam,lParam);
		break;
	case WM_MOUSEMOVE:
		lRet = OnWmMouseMove(hWnd, uMsg, wParam, lParam);
		break;
#ifdef WM_MOUSEWHEEL
	case WM_MOUSEWHEEL:
		lRet = OnWmMouseWheel(hWnd, uMsg, wParam, lParam);
		break;
#endif //WM_MOUSEWHEEL
	case WM_TIMER:
		lRet = OnWmTimer(hWnd, uMsg, wParam, lParam);
		break;
	case WM_MENUSELECT:
		lRet = OnWmMenuSelect(hWnd,uMsg,wParam,lParam);
		break;
	default:
		lRet = DefWindowProc(hWnd,uMsg,wParam,lParam);
		break;
	}

	return lRet;
}

